/*
 Message # 53  Area : Nueral Net 
  Dated : 25 Mar 90 16:49:00
   From : Gary Coulter On 130/40
     To : ALL On 130/34
 Subject: NEWRULE.BAS
 Status :

    "Newrule.bas" is a primitive implementation of the Backpropagation
    method of training the weights for an Artificial Neural Network.

    Copyright 1990 by Gary Coulter.  All rights reserved.
        fidonet 1:130/40, 817-923-8888

	 Permission is granted to distribute this program through computer
    bulletin board systems.  No fee may be charged and commercial use
    is forbidden without the permission of the author.
    The sole purpose of this program was so that the author could
    test out his own understanding of the method called Backpropagation.
    No claims are made about the utility or value of the program.  I can
    only hope that it may prove useful as an educational tool for someone
    attempting to understand artificial neural networks.

	Modified: 11-Apr-90 for Turbo C - C. Edward Nicol

*/

#include <conio.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


void main (void)
{
FILE *fp;

float WEIGHTJ[21][21];  /* 20 bit input and 10 bit output */
float WEIGHTK[21][10];
float NETJ[21], NETK[10]; /* Hold the net values for each neuron */
float OUTJ[21], OUTK[10];
float DELTAJ[21], DELTAK[10];
float SUMDELTA;

float BIT[10][21] = {		/* Bit map of each character in the training set */
	{0, 1, 0, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 1},
	{0, 1, 1, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 1, 1, 1, 1},
	{1, 1, 1, 0, 0, 0, 0, 1, 0, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1},
	{1, 0, 0, 0, 1, 0, 1, 0, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 1, 0, 1},
	{1, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 0, 1},
	{0, 1, 1, 1, 1, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1},
	{1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 1},
	{0, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 0, 1},
	{0, 1, 1, 0, 1, 0, 0, 1, 0, 1, 1, 1, 0, 0, 0, 1, 1, 1, 1, 0, 1},
	{0, 1, 1, 0, 1, 0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 1, 0, 1, 1, 0, 1}};

/* The "coded" equivalent of the target */
float TARGET[10][10] = {
	{1, 0, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 1, 0, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 1, 0, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 1, 0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 1, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 1, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 1, 0, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 1, 0, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 1, 0},
	{0, 0, 0, 0, 0, 0, 0, 0, 0, 1}};

	int j,k,l,m,n;

clrscr();
if ((fp = fopen ("nr.dat","rb")) != NULL)
	{/* read weights */
		cprintf ("Reading weights.\n\r");
		fread (&n,sizeof(n),1,fp);
		fread (WEIGHTJ,sizeof(WEIGHTJ),1,fp);
		fread (WEIGHTK,sizeof(WEIGHTK),1,fp);
		fclose (fp);
	}/* end read weights */
else
	{/* initialize weights */
		n = 1;
		randomize ();		/* stir up the random number generator */
		for (j=0; j < 21; ++j)
			{/* initialize weights with value from -1.25 to 1.25 */
				for (k=0; k < 21; ++k)
					{/* Layer J */
						WEIGHTJ[j][k] = (float)(random(250) - 125) / 100.0;
					}
			}
		for (j=0; j < 21; ++j)
			{/* and layer K */
				for (k=0; k < 10; ++k)
					{
						WEIGHTK[j][k] = (float)(random(250) - 125) / 100.0;
					}
			}
	}/* end initialize weights */

/* The trainning loop starts here */
clrscr ();
cprintf ("Neuron #   actual   target\n\r");
for (; n<=1000; ++n)
	{/* This is an arbitrary count value */
		for (m=0; m < 10; ++m)
			{/* for each character in the training set */
			/*  FORWARD PASS calculates the nets and outs for each neuron */
				memset (NETJ,0,sizeof(NETJ));	/* clear entire array */
				for (k=0; k < 21; ++k)
					{/* 20 input bits and a bias value */
						for (l=0; l < 21; ++l)
							NETJ[k] = NETJ[k] - BIT[m][l] * WEIGHTJ[l][k];
						OUTJ[k] = 1 / (1 + exp(NETJ[k])); /* non - linearity */
					}
            OUTJ[20] = 1; /* --- force the bias neuron to one */
				/* calculate nets and out for layer K (Output layer) */
				gotoxy (1,2);
				memset (NETK,0,sizeof(NETJ));	/* clear entire array */
				for (k=0; k<10; ++k)
					{
						for (l=0; l < 21; ++l)
							NETK[k] = NETK[k] - OUTJ[l] * WEIGHTK[l][k];
						OUTK[k] = 1 / (1 + exp(NETK[k])); /* -- Squashing Function */
                  /* -- Find the Deltas for the output layer */
                        DELTAK[k] = OUTK[k] * (1 - OUTK[k]) * (TARGET[m][k] - OUTK[k]);
						cprintf ("  %2d       %5.4f     %2g\n\r",
							k,OUTK[k], TARGET[m][k]);
					}
				cprintf ("\n\r\rPass number %d  Character number %d", n, (m+1)%10);
				/* reverse pass.. start adjusting the weights */
				for (j=0; j < 21; ++j)
					{
						SUMDELTA = 0; /* -- clear out from previous pass */
						for (k=0; k < 10; ++k)
							{
								/* -- Prepare for the hidden layer, first */
								SUMDELTA = SUMDELTA + DELTAK[k] * WEIGHTK[j][k];
                     	/* -- Then adjust the weights for the K layer */
								WEIGHTK[j][k] = WEIGHTK[j][k] + DELTAK[k] * OUTJ[j];
							}
               /* -- Now get the deltas for the hidden layer. */
					DELTAJ[j] = OUTJ[j] * (1 - OUTJ[j]) * SUMDELTA;
					}
         /* Adjust the weights for the hidden layer. */
			for (k=0; k < 21; ++k)
	     		for (j=0; j < 21; ++j)
					WEIGHTJ[j][k] = WEIGHTJ[j][k] + DELTAJ[k] * BIT[m][j];
		}
	if (kbhit())
		{
			if (getch() == 27)
				break;
			getch();
		}
	}

if ((fp = fopen ("nr.dat","wb+")) != NULL)
	{/* save weights */
		printf ("\n\r\rSaving weights at Count = %d.\n\r",n);
		fwrite (&n,sizeof(n),1,fp);
		fwrite (WEIGHTJ,sizeof(WEIGHTJ),1,fp);
		fwrite (WEIGHTK,sizeof(WEIGHTK),1,fp);
		fclose (fp);
	}/* end save weights */
/*
    -- The program should be modified if you want to save the weights
    -- or for that matter, do anything that is actually useful.  Each of
    -- the ascii characters '0' - '9' are translated into one of ten
    -- bits being on.  So an output of 100000000 = "1", 0100000000 ="2",
    -- 0010000000 = "3" and so on ... until 0000000001 = "0".
    -- The program never actually produces zeroes or ones precisely,
    -- but they are relatively close to the desired values.
    -- By adjusting the appropriate indices and providing a training set,
    -- this program could be modified to learn larger character arrays.
*/
}/* end main */

